/*-------------------------------------------------------
    ALEA.C
    Sous-programmes  de tirage aleatoire
    Gerard Govaert  et Van Mo DANG  Aout 97
-------------------------------------------------------*/
#include <sys/types.h>   /* time_t */
#include <time.h>        /* time() */
#include <stdlib.h>      /* srand48(), lrand48() */
#include <stdio.h>

#include "da_alea.h"

/*-------------------------------------------------------*/
void  RandomSeedByTime( void ) 
{
    time_t   t ;
    t = time( 0 ) ;
    srand48( t ) ;
}
/*-------------------------------------------------------*/
int   RandomInteger( int Mini, int Maxi ) 
{
    int       span ;
    long int  nrandom ;
    int       result ;

    if ( Mini >= Maxi ) return Maxi ;
    span = Maxi - Mini + 1 ;
    nrandom = lrand48( ) ;
    result = ( (int) ( nrandom % span ) ) + Mini  ;
    return  result ;
}

/*-------------------------------------------------------*/
int Multinomial(int km, float *tk) 
/*
 Entrees
     km           nombre de modalites
     tk           probabilites de chaque modalites

 Retour
     valeur retenue
*/

{
    int         k ;
    float      pk,x;
    double     random;
    int result;

    x = drand48( ) ;
    pk=0.0;
    for (k=1 ; k <= km ; ++k)
    {
	pk = pk + tk[k];
	if (x <= pk) return k;
    }
    return km;
}

