#include "semms_typ.h"    /* DataT, ... */

/*
  V1.06-a   17-JUN-1998  NoiseModel -> StatModel
  V1.06-b   30-JUN-1998  ClassifyByNem const NemParaP, no const DataP (sort)
  V1.06-c   20-SEP-1998  Add LabelToClassVector
  V1.06-d   21-SEP-1998  Add TieRule arg to ComputeMAP
*/

 

   int ClassifyByAlgo
        ( 
          const AlgoParaT     *SemmsParaP,        /* I */
          const SpatialT      *SpatialP,        /* I */
          DataT               *DataP,           /* I/O */
          StatModelT          *StatModelP,      /* I/O */
          double              *ClassifM,
          WorkingT*           WorkPing,
          MSCritT             *MSCritP,
          VarParamT           *VarParamP,
          double              *Increase,
	  CriterT             *CriterP,          /* O */  /*V1.03-f*/
          double              *EBlist   
        ) ;

   int ReadParamFile
         (
	     const ModelSpecT ModelSpecP,
             const char  *FileName,   
             const int   K,  /* nb of classes */  
             const int   D,   /* nb of variables */
             double*       Center,
             double*       Disp 
         );

    int  ReadListFile
         ( 
          const char  *ListName,
          double       **EBlist
         ) ;

   int ComputeMAP
        ( 
          const double* ClassifM,   /* I */
          int          Ipt,        /* I */
          int          Nk,         /* I */
	  TieET        TieRule,    /* I */ /*V1.06-d*/
          int*         kmaxesV     /* T [Nk] */
        ) ;


   void LabelToClassVector
       ( 
          const int Nk,    /* I: number of classes */
          const int Label, /* I: class of interest 0..Nk-1 */
          double* Cout_K    /* O: classification vector [Nk] */
        ) ;



  
   int  InitPartitionSort
        ( 
	 const DataT*    DataP,      /* I */
	 int             Nk,         /* I */
	 int             SortedVar,  /* I : sorted variable : 0..dim-1 */
	 double           *ClassifM   /* O (to allocate before call) */
	) ;


   StatusET ComputeBIC   
   ( 
       const ModelSpecT*    SpecP,       /* I */ 
       const ModelParaT*    ParaP, 
       const DataT*         DataP,       /* I */ 
       const SpatialT*      SpatialP, 
       const AlgoParaT*     AlgoParaP, 
       const double*        Hclassif,
       const double*        ICMclassif,
       const CriterT*       CriterP,
       MSCritT*             MSCritP,
       WorkingT*            WorkP 
  );


 StatusET HardClassif
   (
     const AlgoParaT*    AlgoParaP,
     const DataT*        DataP,
     const int           Npt,
     const int           Nk,
     const double*        Fclassif, /* fuzzy classif, i.e probas */
     double*                Hclassif /* hard classif provided by MAP on Fclassif */
   
   );


void CreateGibbs(
		 DataT*      DataP,
		 AlgoParaT*  AlgoParaP,
		 StatModelT* StatModelP,
		 SpatialT*   SpatialP
);




 int FieldAlgo
     (
      const DataT*        DataT,
      const AlgoParaT*    AlgoParaP,
      const SpatialT*     SpatialP,
      const ModelSpecT*   SpecP,
      const SampleDesT*   DescP,
      ModelParaT*         ParaP,
      double*              PostM,
      MSCritT*            MSCritP,
      double*              Increase,
      WorkingT*           WorkP,
      int*             LastCPUtime
      );




