/*\
    Prototypes of nem_noi.c exported functions

    1.05-a    12-JAN-1997  MissMode in ParaP*V*I
    1.05-b    17-JAN-1997  EmptyK_P and StatusET return in ParaP*V*I
\*/

#include "semms_typ.h"    /* NoiseParaT, ... */

int DensPkVkI          /* ret : 0 if OK, -1 if zero density */
        (
            int                Nd,         /* I : point dimension */
            int                Ik,         /* I : class number : 0..Nk-1 */
            const NoiseParaT*  NoiseP,     /* I : noise parameters */
            const double*       XV,         /* I : point (dim d) */
            double*             FkP,        /* O : density for class Ik */
            double*             LogFkP      /* O : log of density */
        ) ;


StatusET            /* ret : OK, W_EMPTYCLASS or E_MEMORY *//*V1.05-b*/
ParaP_V_I 
(
  const double   *Cih_nk,    /* I : classification matrix (N,K) */
  const DataT   *DataP,     /* I : observed points */
  int           K,          /* I : number of classes */
  MissET        MissMode,   /* I : how to treat missing data */ /*V1.05-b*/

  int           *EmptyK_P,  /* O : which empty class (1..K) or 0 *//*V1.05-b*/
  NoiseParaT    *NoiseParaP /* O : estimated parameters */
 ) ;

StatusET            /* ret : OK, W_EMPTYCLASS or E_MEMORY *//*V1.05-b*/
ParaPkV_I 
(
  const double   *Cih_nk,    /* I : classification matrix (N,K) */
  const DataT   *DataP,     /* I : observed points */
  int           K,          /* I : number of classes */
  MissET        MissMode,   /* I : how to treat missing data */ /*V1.05-b*/

  int           *EmptyK_P,  /* O : which empty class (1..K) or 0 *//*V1.05-b*/
  NoiseParaT    *NoiseParaP /* O : estimated parameters */
 ) ;

StatusET            /* ret : OK, W_EMPTYCLASS or E_MEMORY *//*V1.05-b*/
ParaP_VkI 
(
  const double   *Cih_nk,    /* I : classification matrix (N,K) */
  const DataT   *DataP,     /* I : observed points */
  int           K,          /* I : number of classes */
  MissET        MissMode,   /* I : how to treat missing data */ /*V1.05-b*/

  int           *EmptyK_P,  /* O : which empty class (1..K) or 0 *//*V1.05-b*/
  NoiseParaT    *NoiseParaP /* O : estimated parameters */
 ) ;

StatusET            /* ret : OK, W_EMPTYCLASS or E_MEMORY *//*V1.05-b*/
ParaPkVkI 
(
  const double   *Cih_nk,    /* I : classification matrix (N,K) */
  const DataT   *DataP,     /* I : observed points */
  int           K,          /* I : number of classes */
  MissET        MissMode,   /* I : how to treat missing data */ /*V1.05-b*/

  int           *EmptyK_P,  /* O : which empty class (1..K) or 0 *//*V1.05-b*/
  NoiseParaT    *NoiseParaP /* O : estimated parameters */
 ) ;


